.range {
    font-family: inherit;
    font-size: inherit;
    display: inline-flex;
    flex-direction: column;

    .label {
        display: flex;
        flex-wrap: nowrap;
        align-items: center;
        flex: 30%;
        color: $color-base;
        min-height: $line-height * 1em;

        @include padding(2, 3, 2, 0);

        .mark {
            color: $color-input-error;

            @include marginLeft(1);
        }

        .helper {
            @include marginLeft(2);
        }
    }

    &.label-position {
        &.top {
            display: inline-flex;
            flex-wrap: nowrap;
            flex-direction: column;
        }

        &.left {
            display: flex;
            flex-wrap: nowrap;
            flex-direction: row;
            justify-content: space-between;
            align-items: flex-start;

            @include marginBottom(6);
        }
    }

    input[type="range"] {
        appearance: none;
        cursor: pointer;
        outline: none;
        overflow: hidden;
        border-radius: $space * 2;
        width: 100%;

        &::-webkit-slider-runnable-track {
            height: $space * 4;
            background-color: $grey-300;
            border-radius: $space * 2;
        }
        &::-moz-range-track {
            height: $space * 4;
            background-color: $grey-300;
            border-radius: $space * 2;
        }

        &::-webkit-slider-thumb {
            appearance: none;
            height: $space * 4;
            width: $space * 4;
            background-color: #FFFFFF;
            border: 1px solid $grey-300;
            border-radius: 50%;
        }
        &::-moz-range-thumb {
            appearance: none;
            height: $space * 4;
            width: $space * 4;
            background-color: #FFFFFF;
            border: 1px solid $grey-300;
            border-radius: 50%;
        }

        &::-webkit-slider-thumb {
            box-shadow: calc(-1000px - 0.5rem) 0 0 1000px $red-500;
        }
        &::-moz-range-thumb {
            box-shadow: calc(-1000px - 0.5rem) 0 0 1000px $red-500;
        }
    }

    &.error {
        .wrapper {
            border-color: $color-input-border-error;

            .icon__left,
            .icon__right {
                cursor: default;
                color: $color-input-error;
            }
        }
    }

    &.disabled {
        input[type="range"] {
            cursor: default;

            &::-webkit-slider-thumb {
                width: 0;
                box-shadow: -1000px 0 0 1000px $red-500;
            }

            &::-moz-range-thumb {
                width: 0;
                box-shadow: -1000px 0 0 1000px $red-500;
            }
        }
    }

    &.readonly {
        input[type="range"] {
            cursor: default;
        }
    }

    .error--wrapper {
        flex: 70%;
        display: flex;
        flex-direction: column;

        .error {
            font-size: $font-size-small;
            color: $color-input-error;

            @include marginLeft(3);
        }
    }

    .value--wrapper {
        display: inline-flex;
        flex-direction: row;
        align-items: center;
        gap: $space * 4;

        .value {
            width: $space * 18;
        }
    }

    .labels--wrapper {
        flex-grow: 1;
        display: inline-flex;
        flex-direction: row;
        align-items: center;
        gap: $space * 2;

        span {
            font-size: $font-size-small;
            white-space: nowrap;
            color: $color-base-light;
        }
    }
}

